{% extends "page.html" %}
{% block content %}
    <section>
        <div class="container mx-auto">
            <div class="text-center my-3">
                <h1>Usage Statistics</h1>
            </div>
            <div id="stats-plot"></div>
            <div class="col text-right">
                <a id="download-csv" href="#" class="btn btn-secondary btn-sm">
                    Download CSV
                </a>
            </div>
        </div>
    </section>
    <script src="https://cdn.plot.ly/plotly-latest.min.js"></script>
    <script>
      let usage = {{ usage|safe }};
      let data = [];
      data.push({
        x: usage.timestamp,
        y: usage.total,
        type: "scatter",
        mode: "lines",
        name: "Total signed-in"
      });
      data.push({
        x: usage.timestamp,
        y: usage.unique,
        type: "scatter",
        mode: "lines",
        name: "Unique users"
      });
      data.push({
        x: usage.timestamp,
        y: usage.actions,
        type: "scatter",
        mode: "lines",
        name: "Activity",
        visible: "legendonly"
      });
      let rangeSelectorOptions = {
        buttons: [{
          step: 'day',
          stepmode: 'backward',
          count: 1,
          label: 'Day'
        }, {
          step: 'day',
          stepmode: 'backward',
          count: 7,
          label: 'Week'
        }, {
          step: 'month',
          stepmode: 'backward',
          count: 1,
          label: 'Month'
        }, {
          step: 'year',
          stepmode: 'backward',
          count: 1,
          label: 'Year'
        }, {
          step: 'all',
        }],
        x: 1,
        y: 1.07,
        yanchor: "bottom",
        xanchor: "right"
      };
      let layout = {
        height: 600,
        paper_bgcolor: "rgba(0, 0, 0, 0)",
        plot_bgcolor: "white",
        // Draw a box around the plot using mirror
        xaxis: {
          linecolor: "black",
          linewidth: 1,
          mirror: true,
          range: [new Date() - 28 * 24 * 60 * 60 * 1000, new Date()],
          autorange: false,
          rangeselector: rangeSelectorOptions,
          rangeslider: {}
        },
        yaxis: {
          linecolor: "black",
          linewidth: 1,
          mirror: true,
          fixedrange: false
        },
        // Uses most space
        margin: {
          l: 40,
          r: 10,
          b: 40,
          t: 5
        },
        // Above the plot
        legend: {
          x: 0,
          y: 1.2
        }
      };
      Plotly.newPlot("stats-plot", data, layout);
      // download button for the data
      document.querySelector("#download-csv").addEventListener("click", function() {
        // Don't regenerate csv if it's already been created
        if (this.getAttribute("href") !== "#") {
          // Click action continues
          return true;
        }
        // Build csv as a string
        let csv = "timestamp,total,unique,actions\n";
        for (let idx = 0; idx < usage.timestamp.length; idx++) {
          csv += [
            usage.timestamp[idx],
            usage.total[idx],
            usage.unique[idx],
            usage.actions[idx]
          ].join(",") + "\n";
        }
        // Use today's date as the filename
        let now = new Date();
        let fileName = "stats-" + now.toISOString().split("T")[0] + ".csv";
        // Set as html5 download
        this.setAttribute("href", 'data:text/csv;charset=utf-8,' + encodeURIComponent(csv));
        this.setAttribute("download", fileName);
        // Allow click action to proc on the element
        return true;
      });
    </script>
{% endblock content %}
